package com.jzq.cinbac.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jzq.cinbac.common.R;
import com.jzq.cinbac.entity.CinArea;
import com.jzq.cinbac.entity.CinBuilding;
import com.jzq.cinbac.entity.CinModule;
import com.jzq.cinbac.entity.vo.AreaQuery;
import com.jzq.cinbac.entity.vo.BuildingQuery;
import com.jzq.cinbac.service.CinBuildingService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author jzq
 * @since 2022-06-18
 */
@RestController
@RequestMapping("/cinbac/cin-building")
@CrossOrigin
public class CinBuildingController {
    @Autowired
    private CinBuildingService cinBuildingService;

    @PostMapping("getBuildingInfoList")
    public R getModuleInfoList(@RequestBody(required = false) BuildingQuery buildingQuery){
//        System.out.println(lineQuery);
        Page<CinBuilding> buildingPage =new Page<>(buildingQuery.getPage(),buildingQuery.getLimit());

        QueryWrapper<CinBuilding> wrapper =new QueryWrapper<>();
        cinBuildingService.page(buildingPage,null);

        long total = buildingPage.getTotal();
        List<CinBuilding> cinBuildingList =buildingPage.getRecords();

        return R.ok().data("total",total).data("buildingList",cinBuildingList);
    }

}

