package com.jzq.cinbac.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 
 * </p>
 *
 * @author jzq
 * @since 2022-06-18
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="CinPoint对象", description="")
public class CinPoint implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty(value = "点经度")
    private Double longitude;

    @ApiModelProperty(value = "点纬度")
    private Double latitude;

    @ApiModelProperty(value = "点高度")
    private Double height;

    @ApiModelProperty(value = "名称")
    private String name;

    @ApiModelProperty(value = "是否为一个可见点元素")
    private Integer visibility;

    @ApiModelProperty(value = "描述")
    private String des;

    @ApiModelProperty(value = "所属建筑的id")
    private Integer buildingId;

    @ApiModelProperty(value = "所属建筑楼层")
    private Integer floor;

    @ApiModelProperty(value = "所属楼层区域")
    private Integer pPartition;

    @ApiModelProperty(value = "1:电梯，2:楼梯，3:扶梯，4:房间，5:走廊虚拟房间")
    private Integer type;

    @ApiModelProperty(value = "0:不是连接点，1:上下连接点，2:上连接点，3:下连接点，4:水平连接点")
    private Integer connection;

    private Date gmtCreated;

    private Date gmtModified;


}
