package com.jzq.cinpre.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.jzq.cinpre.common.R;
import com.jzq.cinpre.entity.CinBuildingModule;
import com.jzq.cinpre.service.CinBuildingModuleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author jzq
 * @since 2022-06-22
 */
@RestController
@RequestMapping("/cinpre/cin-building-module")
@CrossOrigin
public class CinBuildingModuleController {

    @Autowired
    private CinBuildingModuleService cinBuildingModuleService;

    @GetMapping("getBuildingModuleByAreaId/{id}")
    public R getBuildingModuleByAreaId(@PathVariable("id") Integer id){
        QueryWrapper<CinBuildingModule> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("area_id",id);
        List<CinBuildingModule> list = cinBuildingModuleService.list(queryWrapper);
        System.out.println(list);
        return R.ok().data("buildingModuleList",list);
    }

    @GetMapping("getBuildingModuleByBuildingId/{id}")
    public R getBuildingModuleByBuildingId(@PathVariable("id") Integer id){
        CinBuildingModule cinBuildingModule = cinBuildingModuleService.getById(id);

        return R.ok().data("buildingModule",cinBuildingModule);
    }

}

