package com.jzq.cinpre.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.jzq.cinpre.common.R;
import com.jzq.cinpre.entity.CinLine;
import com.jzq.cinpre.entity.CinPoint;
import com.jzq.cinpre.service.CinAreaService;
import com.jzq.cinpre.service.CinLineService;
import com.jzq.cinpre.service.CinPointService;
import com.jzq.cinpre.utils.Dijkstra;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author jzq
 * @since 2022-06-15
 */
@RestController
@RequestMapping("/cinpre/cin-point")
@CrossOrigin
public class CinPointController {

    @Autowired
    private CinPointService cinPointService;
    @Autowired
    private CinLineService cinLineService;

    @GetMapping("getPoint")
    public R getPoint(){
        QueryWrapper<CinPoint> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("visibility",1);
        List<CinPoint> list = cinPointService.list(queryWrapper);
        return R.ok().data("pointlist",list);
    }

    @GetMapping("getAllPoint")
    public R getAllPoint(){
//        QueryWrapper<CinPoint> queryWrapper = new QueryWrapper<>();
//        queryWrapper.eq("visibility",1);
        List<CinPoint> list = cinPointService.list(null);
        return R.ok().data("pointlist",list);
    }

    @GetMapping("getPath/{start}/{end}")
    public R getPath(@PathVariable("start") Integer start,@PathVariable("end") Integer end){
        List<CinPoint> pointList = cinPointService.list(null);
        List<CinLine> lineList = cinLineService.list(null);

        Dijkstra dijkstra = new Dijkstra();
        List<CinPoint> list = dijkstra.getPath(pointList,lineList,cinPointService.getById(start),cinPointService.getById(end));

        return R.ok().data("list",list);
    }

}

