package com.jzq.cinpre.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.jzq.cinpre.entity.CinArea;
import com.jzq.cinpre.entity.CinBuilding;
import com.jzq.cinpre.entity.CinModule;
import com.jzq.cinpre.mapper.CinAreaMapper;
import com.jzq.cinpre.service.CinAreaService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jzq.cinpre.service.CinBuildingService;
import com.jzq.cinpre.service.CinModuleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author jzq
 * @since 2022-06-15
 */
@Service
public class CinAreaServiceImpl extends ServiceImpl<CinAreaMapper, CinArea> implements CinAreaService {
    @Autowired
    private CinBuildingService cinBuildingService;

    @Autowired
    private CinAreaService cinAreaService;

    @Override
    public List<CinModule> getModuleByArea(Integer id) {
        QueryWrapper<CinBuilding> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("area_id",id);
        List<CinBuilding> list = cinBuildingService.list(queryWrapper);

        List<CinModule> res = new ArrayList<>();
//        List<CinModule> list1 = new ArrayList<>();

        for(CinBuilding cinBuilding:list){
            List<CinModule> list1 = cinBuildingService.getModuleByBuilding(cinBuilding.getId());
            for(CinModule cinModule:list1){
                res.add(cinModule);
            }
        }

        return res;
    }
}
