package com.jzq.cinpre.service.impl;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.jzq.cinpre.entity.CinBuilding;
import com.jzq.cinpre.entity.CinModule;
import com.jzq.cinpre.mapper.CinBuildingMapper;
import com.jzq.cinpre.service.CinBuildingService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jzq.cinpre.service.CinModuleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author jzq
 * @since 2022-06-15
 */
@Service
public class CinBuildingServiceImpl extends ServiceImpl<CinBuildingMapper, CinBuilding> implements CinBuildingService {
    @Autowired
    private CinModuleService cinModuleService;

    @Override
    public List<CinModule> getModuleByBuilding(Integer id) {
        QueryWrapper<CinModule> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("building_id",id);
        List<CinModule> list = cinModuleService.list(queryWrapper);
        return list;
    }
}
