package com.jzq.cinpre.utils;

import com.jzq.cinpre.entity.CinLine;
import com.jzq.cinpre.entity.CinPoint;

import java.util.*;

public class Dijkstra {
    public static int MaxValue = 100000;

    public void aa(int[][] distance,int n,int startindex){
        Graph graph = new Graph(distance,n);
        graph.dsj(startindex);

        for(int i=0;i<n;i++){
            Stack<Integer> route = new Stack<>();
            route.add(i);
            int pre = i;
//            System.out.println(pre);
            System.out.println(startindex+ "到"+i+"的最短距离是：" + graph.vv.dis[i]);
            while(pre!=startindex){
                pre = graph.vv.pre_visited[pre];
//                System.out.println(pre);
                route.push(pre);
            }
            while(!route.isEmpty()){
                System.out.println(startindex+"到"+i+"的路径为："+route.pop()+"->");
            }

        }
    }

    public List<CinPoint> getPath(List<CinPoint> pointList, List<CinLine> lineList, CinPoint start, CinPoint end){
        //初始化邻接矩阵
        int n = pointList.size();
        int[][] distance = new int[n][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                distance[i][j] = MaxValue;
            }
        }

        //矩阵下标到点id的映射
        CinPoint[] id = new CinPoint[pointList.size()];
        //点id到矩阵下标的映射
        Map<Integer,Integer> map = new HashMap<>();
        int a=0;

        for(CinPoint cinPoint:pointList){
            int pid = cinPoint.getId();
            id[a] = cinPoint;
            map.put(pid,a++);
        }

        //构建邻接矩阵
        for(CinLine cinLine:lineList){
            int index1 = map.get(cinLine.getPId());
            int index2 = map.get(cinLine.getPpId());
            int wei = cinLine.getWeight();
            distance[index1][index2] = wei;
            distance[index2][index1] = wei;
        }

        int startindex = map.get(start.getId());
        int endindex = map.get(end.getId());

        Graph graph = new Graph(distance,n);
        graph.dsj(startindex);

//        for(int i=0;i<n;i++){
//            Stack<Integer> route = new Stack<>();
//            route.add(i);
//            int pre = i;
//            System.out.println(startindex+ "到"+i+"的最短距离是：" + graph.vv.dis[i]);
//            while(pre!=startindex){
//                pre = graph.vv.pre_visited[pre];
//                route.push(pre);
//            }
//            while(!route.isEmpty()){
//                System.out.println(startindex+"到"+i+"的路径为："+route.pop()+"->");
//            }
//
//        }
        Stack<Integer> route = new Stack<>();
        route.add(endindex);
        int pre = endindex;
        while(pre!=startindex){
            pre = graph.vv.pre_visited[pre];
            route.push(pre);
        }
        List<CinPoint> res = new ArrayList<>();
        while(!route.isEmpty()){
            res.add(id[route.pop()]);
        }

        return res;
    }

    class Graph{
        int[][] distance;
        int len;
        VisitedVertex vv;

        public Graph(int[][] distance, int len) {
            this.distance = distance;
            this.len = len;
        }

        private void dsj(int index){
            vv=new VisitedVertex(len,index);
            update(index);
            for(int i=1;i<len;i++){
                index = vv.updateArr();
                update(index);
            }
        }

        private void update(int index){
            int l=0;
            for(int i=0;i<distance[index].length;i++){
                l=vv.getDis(index)+distance[index][i];
                if(!vv.in(i)&&l<vv.getDis(i)){
                    vv.updatePre(i,index);
                    vv.updateDis(i,l);
                }
            }
        }
    }

    class VisitedVertex{
        boolean[] aleady_arr;
        int[] pre_visited;
        int[] dis;

        public VisitedVertex(int len,int startindex) {
            aleady_arr = new boolean[len];
            pre_visited = new int[len];
            dis = new int[len];
            for(int i=0;i<len;i++){
                aleady_arr[i]=false;
                pre_visited[i]=0;
                dis[i]=MaxValue;
            }
            aleady_arr[startindex]=true;
            dis[startindex]=0;
        }

        private boolean in(int index){
            return aleady_arr[index];
        }

        private void updateDis(int index,int len){
            dis[index]=len;
        }

        private void updatePre(int pre,int index){
            pre_visited[pre]=index;
        }

        private int getDis(int index){
            return dis[index];
        }

        private int updateArr(){
            int index=0,min=100000;
            for(int i=0;i<aleady_arr.length;i++){
                if(!aleady_arr[i]&&dis[i]<min){
                    min=dis[i];
                    index=i;
                }
            }
            aleady_arr[index]=true;
            return index;
        }
    }


}
